function Create()

	--Game.DebugOut( "Created" );
	
	local myX = Object.GetProperty("Pos.x");
	local myY = Object.GetProperty("Pos.y");
	
	oreType = "MinedCoal";
	
	local randTyp = math.random(0,9);	
	
	if randTyp <= 2 then
		oreType = "None"
	elseif randTyp >= 3 and randTyp <= 5 then
		oreType = "MinedIron"
	elseif randTyp >= 6 and randTyp <= 7 then
		oreType = "MinedCoal"
	elseif randTyp >= 8 and randTyp <= 8 then
		oreType = "MinedSilver"
	elseif randTyp >= 9 and randTyp <= 9 then
		oreType = "MinedGold";
	end
	
	Object.SetProperty("OreType", oreType);
	
	Object.SetProperty("Minable", false);
	Object.SetProperty("Probed", false);
	Object.SetProperty("DoneProbing", false);
	Object.SetProperty("MiningOngoing", false);
	Object.SetProperty("LastWorkTime", math.floor(math.mod(World.TimeIndex,60)));
	--Game.DebugOut("Probing job created");
	Object.CreateJob("Probe");
end

function Update( goneby )
	local t = math.floor(math.mod(World.TimeIndex,60));
	if Object.GetProperty("LastWorkTime") == nil then
		Object.SetProperty("LastWorkTime",t);
	end
	if math.mod(t,2) == 0 and Object.GetProperty("LastWorkTime") ~= t then
		--Game.DebugOut("Curr Time: "..tostring(t).." & LastWorkTime: "..tostring(Object.GetProperty("LastWorkTime"))); 	
		Object.SetProperty("LastWorkTime", t);
		local oreType = Object.GetProperty("OreType");
		if Object.GetProperty("DoneProbing") == true and oreType == "None" then
			Object.SetProperty("Tooltip", "tt_oretypenone");
			return;
		end
		
		local myX = Object.GetProperty("Pos.x");
		local myY = Object.GetProperty("Pos.y");
		local mat = Object.GetMaterial ( myX, myY);
		
		if mat ~= "Dirt" then
			Object.SetProperty("Tooltip", "tt_wrongground");
			return;
		end
		
		--Object.SetProperty("Tooltip", "Probed: "..tostring(Object.GetProperty("Probed")).."\n".."Minable: "..tostring(Object.GetProperty("Minable")).."\n OreType: "..tostring(Object.GetProperty("OreType")));
		
		if Object.GetProperty("MiningOngoing") == true then
			--Game.DebugOut("MiningOngoing so decrease exercise need");
			removeExerciseNeed();
		end
		
		if Object.GetProperty("Minable") and oreType ~= "None" then
			--Game.DebugOut("Created mining job")
			Object.CreateJob("Mining");
			Object.SetProperty("Tooltip", "tt_miningjob");
			Object.SetProperty("Minable", false);
			Object.SetProperty("MiningOngoing", true);
			return;
		end

		if Object.GetProperty("Probed") == true and Object.GetProperty("DoneProbing") == false then
			--Game.DebugOut("Obj Prop: Probed = TURE")
			--Game.DebugOut("Curr age: "..tostring(Object.GetProperty("Age")));
			
			Object.SetProperty("DoneProbing", true);
			
			local subType = 3;
			if oreType == "MinedCoal" then
				subType = 2;
			elseif oreType == "MinedSilver" or oreType == "MinedIron" then
				subType = 4;
			elseif oreType == "MinedGold" then
				subType = 5;
			end
			
			local currSubtype = Object.GetProperty("SubType");
			if currSubtype ~= subType then
				Object.SetProperty("SubType", subType);
			end
			
		end
	end
end

function removeExerciseNeed()
	local Prisoners = this.GetNearbyObjects("Prisoner",1)
	for thatPrisoner, distance in pairs(Prisoners) do
		local exerciseNeed = thatPrisoner.Needs.Exercise;
		local sleepNeed = thatPrisoner.Needs.Sleep;
		if exerciseNeed == nil or exerciseNeed < 1 then
			return;
		end
		if sleepNeed == nil or sleepNeed >=100 then
			return;
		end
		sleepNeed = sleepNeed+0.4;
		thatPrisoner.Needs.Sleep = sleepNeed;
		exerciseNeed = exerciseNeed-0.6;
		thatPrisoner.Needs.Exercise = exerciseNeed;
	end
end

function JobComplete_Probe()
	
	Object.SetProperty("Probed", true);
	Object.SetProperty("Minable", true);
	
	Object.SetProperty("SubType", 1);
	
	--Game.DebugOut("JobComplete_Probe");
	--Game.DebugOut("Probed: "..tostring(this.GetProperty("Probed")).."Minable: "..tostring(this.GetProperty("Minable")));
end

function JobComplete_Mining()
	local myX = Object.GetProperty("Pos.x");
	local myY = Object.GetProperty("Pos.y");
	
	removeExerciseNeed();
	
	local minedOre = Object.Spawn(Object.GetProperty("OreType"), myX, myY);
	
	
	if minedOre ~= nil then
		local vX = math.ceil(math.random(-4,4)) * math.random(0,1);
		local vY = math.ceil(math.random(-4,4)) * math.random(0,1);
		Object.ApplyVelocity(minedOre, vX, vY);
	end
	Object.SetProperty("Minable", true);
end